package TriggersPool;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.Binding;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;

import java.util.Hashtable;

public
class WasJndi
{

	public static void main(String [] args)
	{
		try
		{
			String providerURL;
			if (args.length == 0)
			{
				providerURL = "iiop://localhost:900";
			}
			else
			{
				providerURL = args[0];
			}
				

			// Create the initial context.  The environment
			// information specifies the JNDI provider to use
			// and the initial URL to use (in our case, a
			// directory in URL form -- file:///...).
			Hashtable hs = new Hashtable();
			hs.put( Context.INITIAL_CONTEXT_FACTORY, "com.ibm.websphere.naming.WsnInitialContextFactory");
									// Sun uses: "com.sun.jndi.fscontext.RefFSContextFactory"
			hs.put( Context.PROVIDER_URL, providerURL);
			Context context = new InitialContext(hs);
			// If you provide no other command line arguments,
			// list all of the names in the specified context and
			// the objects they are bound to.
			if (args.length <= 1)
			{
				NamingEnumeration listNames = context.listBindings("");
				while (listNames.hasMore())
				{
					Binding binding = (Binding)listNames.next();
					System.out.println( binding.getName() + " " + binding.getObject());
					// System.out.println( binding.getName());
				}
			}
			// Otherwise, list the names and bindings for the
			// specified arguments.
			else
			{
				for (int i = 1; i < args.length; i++)
				{
					Object object = context.lookup(args[i]);
					System.out.println( args[i] + " " + object);
				}
			}
			context.close();
		} catch (NamingException namingexception)
		{
			namingexception.printStackTrace();
		}
	}
}
