package Wasacro;

# Class "Wasacro": constructor, methods, destructor, and more

require 5.002;
use English;
use Tk;
use strict;
use Tk::Frame;
@Wasacro::ISA = qw(Tk::Frame);
Construct Tk::Widget 'Wasacro';

my $MAXIMUM_STALE_COUNT = 0;	# max log file no-show count
%Wasacro::OBJTABLE = ();	# list of Filesystem objects

# Public methods.

sub delete_stale_objects {

    my($class, @active_objs) = @ARG;

    my($objname, $found, $actobj);
    foreach $objname (keys %Wasacro::OBJTABLE) {
	$found = 0;
	foreach $actobj (@active_objs) {
	    if ($actobj eq $Wasacro::OBJTABLE{$objname}) {
		$found = 1;
		last;
	    }
	}
	if (not $found and $Wasacro::OBJTABLE{$objname}->{'stale_count'}++
	      >= $MAXIMUM_STALE_COUNT) {
	    my $stale = $Wasacro::OBJTABLE{$objname};
	    $Wasacro::OBJTABLE{$objname}->destroy;
	    delete $Wasacro::OBJTABLE{$objname};
	} elsif ($found) {
	    $Wasacro::OBJTABLE{$objname}->{'stale_count'} = 0;  
	}
    }

}

sub find_object {
    my($class, $objname) = @ARG;

    return $Wasacro::OBJTABLE{$objname};

}

sub Populate {
    my($cw, $args) = @ARG;

    $cw->SUPER::Populate($args);
    my($objname, $error) = (delete $args->{-object_name}, delete $args->{-error});
    $args->{-borderwidth} = 0;

    my $ent = $cw->Component(
        'Entry'             => 'entry',
        -relief             => 'sunken',
        -borderwidth        => 1,
        -font               => 'fixed',
        -width              => ($error ? 60 : 28),    # 15 now 28  These are for led not defined by IBM
    );
    $ent->pack(-side => 'left');

	if (!(defined($cw->{'prevcolor'}))) { $cw->{'prevcolor'} = 'blue'; }

    if (not $error) {
	my $but = $cw->Component(
            'Button'            => 'button',
	    -font               => 'fixed',
            -width              => 10,
	    -relief             => 'flat',
	    # -disabledforeground => $cw->{'prevcolor'},
	    -disabledforeground => 'blue',
	    -state              => 'disabled',
            -pady               => 1,
        );
	$but->pack(-side => 'left');

	my $bar = $cw->Component('Frame' => 'bar', -height => 12);
	$bar->pack(-side => 'left');
    }

    $cw->{'error'}       = $error;
    $cw->{'stale_count'} = 0;

    $Wasacro::OBJTABLE{$objname} = $cw;
    return $cw;

}

sub update_widget {

    my($objref, $acro_g, $msgno, $color) = @ARG;
    my $width = 100;

    my $e = $objref->Subwidget('entry');
    $e->configure(-state => 'normal');
    $e->delete(0, 'end');
    $e->insert(0, $acro_g);
    $e->configure(-state => 'disabled');
    if (not $objref->{'error'}) {
	$objref->Subwidget('button')->configure(-text => "$msgno",-disabledforeground => $objref->{'prevcolor'});
	$objref->Subwidget('bar')->configure(
            -width      => ($width - 89) * 24 - 14,
            -background => $color,
        );
    }
    $objref->{'prevcolor'} = $color;

}

1;
